﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Selectiontest
{
    public class MainWindowViewModel : Notifyable
    { 

        private ObservableCollection<TestModel> models = new ObservableCollection<TestModel>();
        public ObservableCollection<TestModel> Models { get => models; set{ models = value; RaisePropertyChanged(nameof(Models)); } }

        public RelayCommand ButtonClicked { get; set; }
        public RelayCommand AddItemsClicked { get; set; }

        public MainWindowViewModel()
        {
            ButtonClicked = new RelayCommand((o) => true, (o) => OnButtonClicked());
            AddItemsClicked = new RelayCommand((o) => true, (o) => OnAddItemsClicked());

        }

        private void OnAddItemsClicked()
        {
            for (int i = 0; i < 10; i++)
            {
                TestModel m = new TestModel();
                m.Var1 = i.ToString();
                m.Var2 = (i * i).ToString();
                models.Add(m);
            }
            RaisePropertyChanged(nameof(Models));
        }

        private void OnButtonClicked()
        {
            List<TestModel> selectedModels = Models.Where((o) => o.IsSelected).ToList();
            Debug.WriteLine (selectedModels.Count);
        }
    }
}
